<script lang="ts">
import Vue from 'vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

import { SolutionsVideoModal } from '../solutions/index.vue';

export default Vue.extend({
  name: 'IntroBlock',
  components: {
    SolutionsVideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      modal: {
        open: false,
      },
    };
  },
  methods: {
    handleClick(buttonData: any) {
      if (buttonData.modal) {
        this.modal.open = true;
        // Make sure Vimeo analytics work:
        // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
        setTimeout(() => {
          window.__vimeoRefresh();
        }, 3000);
      }
    },
    closeModal() {
      this.modal.open = false;
    },
  },
});
</script>

<template>
  <div class="intro-block">
    <SlpContainer>
      <SlpRow class="slp-align-items-center intro-block__row">
        <SlpColumn :col="6" class="intro-block__col">
          <div>
            <SlpTypography
              tag="h3"
              variant="heading3-bold"
              class="intro-block__header"
            >
              {{ data.title }}</SlpTypography
            >
            <SlpTypography tag="p" variant="body1" class="slp-my-24"
              >{{ data.blurb }}
            </SlpTypography>

            <SlpButton
              class="intro-block__button slp-mr-24"
              variant="primary"
              :data-ga-name="data.primaryButton.data_ga_name"
              :data-ga-location="data.primaryButton.data_ga_location"
              :href="data.primaryButton.href"
              >{{ data.primaryButton.text }}
            </SlpButton>
            <SlpButton
              variant="tertiary"
              class="homepage-hero__secondary-button"
              :href="data.secondary_button.link"
              :data-ga-name="data.secondary_button.data_ga_name"
              :data-ga-location="data.secondary_button.data_ga_location"
              @click.native="handleClick(data.secondary_button)"
              >{{ data.secondary_button.text }}
              <SlpIcon
                name="play-circle-outline"
                variant="marketing"
                size="md"
                class="intro-block__content-icon"
              />
            </SlpButton>
          </div>
        </SlpColumn>
        <SlpColumn :col="6" class="intro-block__col">
          <img
            :src="data.image.src"
            :alt="data.image.alt ?? ''"
            loading="lazy"
          />
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
    <SolutionsVideoModal
      v-show="modal.open"
      light-background
      :visible="modal.open"
      @close="closeModal"
    >
      <template #body>
        <lite-vimeo
          :videoid="
            getVimeoVideoId(
              createVideoSource(data.secondary_button.modal.video_link),
            )
          "
          :videotitle="
            data.secondary_button?.modal?.video_title ?? 'Video player'
          "
          autoplay
        ></lite-vimeo>
      </template>
    </SolutionsVideoModal>
  </div>
</template>

<style lang="scss" scoped>
.intro-block {
  &__content-icon {
    height: 20px;
    width: 20px;
  }
  img {
    width: 100%;
    display: none;
    @media (min-width: $breakpoint-sm) {
      display: block;
    }
  }
  :deep .slp-btn {
    width: 100%;
    justify-content: center;
    &:last-child {
      margin-top: 16px;
      @media (min-width: $breakpoint-sm) {
        margin-top: 0;
      }
    }
    @media (min-width: $breakpoint-sm) {
      width: auto;
    }
  }
  &__header {
    @media (max-width: $breakpoint-sm) {
      font-family: 'GitLab Sans';
      font-size: 40px;
      font-style: normal;
      font-weight: 600;
      line-height: 48px;
      letter-spacing: -1.2px;
    }
  }
  &__row {
    margin-left: -32px;
    @media (min-width: $breakpoint-lg) {
      margin-left: -96px;
    }
  }
  &__col {
    padding-left: 32px;
    @media (min-width: $breakpoint-lg) {
      padding-left: 96px;
    }
  }
}
</style>
